#define _MAX_PATH 256

extern char szFnIn[_MAX_PATH+1];        /* sort input filename */
extern char szFnOut[_MAX_PATH+1];       /* sort output file */
extern char szFnCfg[_MAX_PATH+1];       /* sort configuration file */
extern char szHome[_MAX_PATH+1];        /* Home directory */

/*****************************************************************************/
/* CUSTOM SORT ENTRY POINT FOR BSORT                                         */
/* Input:                                                                    */
/* cTyle     = Custom sort type (1 ... 100) defined in *.cfg CUST{l}/cType   */
/* nBy       = length of this column in bytes                                */
/* el1       = pointer to element1 in the sort array                         */
/* el2       = pointer to element2 in the sort array                         */
/*                                                                           */
/* Output:                                                                   */
/* 0         = both elements are equal                                       */
/* 1         = element1 is smaller than element2                             */
/* -1        = element1 is greater than element2                             */
/*****************************************************************************/
int CustSort(int cType,int nBy,unsigned char *el1,unsigned char *el2)
{
long nVal1, nVal2;

    switch (cType)
    {
    /****** EXAMPLE OF A CUSTOM SORT (TYPE 1) *****************************************/
    /****** IGNORE SIGN: SORT BY ABSOLUTE VALUE ******************************/
    case 1:
        /****** GET THE SIGNED VALUE *****************************************/
        switch (nBy)
        {
        case 1: nVal1 = *(char *)el1; nVal2 = *(char *)el2; break;
        case 2: nVal1 = *(short*)el1; nVal2 = *(short*)el2; break;
        case 4: nVal1 = *(long *)el1; nVal2 = *(long *)el2; break;
        default:
            return(0);
        }

        /****** MAKE UNSIGNED ************************************************/
        if (nVal1 < 0)
            nVal1 = -nVal1;
        if (nVal2 < 0)
            nVal2 = -nVal2;

        /****** CHECK FOR EQUAL **********************************************/
        if (nVal1 == nVal2)
            return(0);

        /****** COPMARE NOT EQUAL ********************************************/
        return((nVal2 > nVal1) ? -1 : 1);

        break;

    /****** DEFAULT SORT JUST BY BYTE VALUES *********************************/
    default:
        while(*el1 == *el2++)
            {
            *el1++;
            if (--nBy <= 0)
                return(0);                  /* equal */
            }
        return((*(--el2) > *el1) ? -1 : 1); /* not equal */
        break;
    }
}

